/**
 PhazaSoft littletools 
 Lichess chat Yandex translator by Phazeus (aka LamLamer)
 For free only!
**/

//Применение Mutation Events является устаревшим. Вместо них используйте MutationObserver.

const {interfaces: Ci,	utils: Cu} = Components;
Cu.import('resource://gre/modules/Services.jsm');
Cu.import("resource://gre/modules/Timer.jsm");
const locationToMatch = 'https?://lichess.org/';
const ignoreFrames = true;
const prefPrefix = 'extensions.LichessChatTranslator.';
const langs = {
	'en':'English',
	'ru':'Russian',
	'af':'Afrikaans',
	'am':'Amharic',
	'ar':'Arabic',
	'az':'Azerbaijan',
	'ba':'Bashkir',
	'be':'Belarusian',
	'bg':'Bulgarian',
	'bn':'Bengali',
	'bs':'Bosnian',
	'ca':'Catalan',
	'ceb':'Cebuano',
	'cs':'Czech',
	'cy':'Welsh',
	'da':'Danish',
	'de':'German',
	'el':'Greek',
	'eo':'Esperanto',
	'es':'Spanish',
	'et':'Estonian',
	'eu':'Basque',
	'fa':'Persian',
	'fi':'Finnish',
	'fr':'French',
	'ga':'Irish',
	'gd':'Scottish',
	'gl':'Galician',
	'gu':'Gujarati',
	'he':'Hebrew',
	'hi':'Hindi',
	'hr':'Croatian',
	'ht':'Haitian (Creole)',
	'hu':'Hungarian',
	'hy':'Armenian',
	'id':'Indonesian',
	'is':'Icelandic',
	'it':'Italian',
	'ja':'Japanese',
	'jv':'Javanese',
	'ka':'Georgian',
	'kk':'Kazakh',
	'km':'Khmer',
	'kn':'Kannada',
	'ko':'Korean',
	'ky':'Kyrgyz',
	'la':'Latin',
	'lb':'Luxembourgish',
	'lo':'Laotian',
	'lt':'Lithuanian',
	'lv':'Latvian',
	'mg':'Malagasy',
	'mhr':'Mari',
	'mi':'Maori',
	'mk':'Macedonian',
	'ml':'Malayalam',
	'mn':'Mongolian',
	'mr':'Marathi',
	'mrj':'Hill Mari',
	'ms':'Malay',
	'mt':'Maltese',
	'my':'Burmese',
	'ne':'Nepali',
	'nl':'Dutch',
	'no':'Norwegian',
	'pa':'Punjabi',
	'pap':'Papiamento',
	'pl':'Polish',
	'pt':'Portuguese',
	'ro':'Romanian',
	'si':'Sinhala',
	'sk':'Slovakian',
	'sl':'Slovenian',
	'sq':'Albanian',
	'sr':'Serbian',
	'su':'Sundanese',
	'sv':'Swedish',
	'sw':'Swahili',
	'ta':'Tamil',
	'te':'Telugu',
	'tg':'Tajik',
	'th':'Thai',
	'tl':'Tagalog',
	'tt':'Tatar',
	'tr':'Turkish',
	'udm':'Udmurt',
	'uk':'Ukrainian',
	'ur':'Urdu',
	'uz':'Uzbek',
	'vi':'Vietnamese',
	'xh':'Xhosa',
	'yi':'Yiddish',
	'zh':'Chinese',
};


var firststart=null;
var yaID = ''; //using if no Yandex API Key specified
var stringBundle = Services.strings.createBundle("chrome://LichessChatTranslator/locale/LichessChatTranslator.properties");


var apikey = '';
var lang = 'en';
var langfrom = 'auto';
var mylangto = 'en';

var toTranslateQueue = [];
var translatedBuffer = '';

var myPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(prefPrefix);
function getPreference() {
	if (myPrefs.prefHasUserValue('apikey')) {
		apikey = myPrefs.getCharPref('apikey', '') || '';
		myPrefs.setCharPref('apikey', apikey);
	}
	if (myPrefs.prefHasUserValue('langfrom')) {
		langfrom = myPrefs.getCharPref('langfrom', 'auto') || 'auto';
		myPrefs.setCharPref('langfrom', langfrom);
	}
	if (myPrefs.prefHasUserValue('lang')) {
		lang = myPrefs.getCharPref('lang', 'en') || 'en';
		myPrefs.setCharPref('lang', lang);
	}
	if (myPrefs.prefHasUserValue('langto')) {
		mylangto = myPrefs.getCharPref('langto', 'en') || 'en';
		myPrefs.setCharPref('langto', mylangto);
	}
}

getPreference();


function get_yaID(sid) {
	let [s1, s2, s3] = sid.split('.');
	sid = s1.split('').reverse().join('') + '.' + s2.split('').reverse().join('') + '.' + s3.split('').reverse().join('');
	return sid += '-1-0';
}


function doMyButtonClick(e) {
	let ts = e.target.ownerDocument.querySelector('.mchat__translate_select');
	if (!ts) return;
	mylangto = ts.value;
	myPrefs.setCharPref('langto', mylangto);
	let tb = e.target.ownerDocument.querySelector('.mchat__say');
	if (tb) {
		if (tb.value.length == 0) return;
		let xhr = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		if (apikey) {
			xhr.onload = function() {
				let res = this.responseXML;
				if (res) {
					if (res.firstChild.getAttribute('lang')) {
						if (res.getElementsByTagName('text')) {
							tb.value = res.getElementsByTagName('text')[0].childNodes[0].nodeValue;
							tb.focus();
						}
					}
				}
			}
			xhr.open('POST', 'https://translate.yandex.net/api/v1.5/tr/translate?key=' + apikey + '&options=1&format=plain&lang=' + ts.value, true);
			xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
			xhr.timeout = 5000;
			xhr.send('key='+apikey+'&options=1&format=plain&lang='+ts.value+'&text='+encodeURIComponent(tb.value.trim().replace(/\s+/g," ")));
		} else {
			let origUrl = 'https://translate.yandex.ru/?lang=en';
			xhr.onload = function() {
				if (!yaID && this.responseURL != origUrl) {
					tb.value = '[ERROR] ' + this.responseURL;
					return;
				} else {
					let res = this.responseText;
					if (res) {
						if (!yaID) {
							let sid = res.match(/\ssid: \'(.*)\'/i);
							if (sid) {
								yaID=get_yaID(sid[1]);
								e.target.ownerDocument.querySelector('.mchat__translate_to').click();
								return;
							}
						} else {
							res = res.match(/\{\s?\"code\"\s?:\s?200,\s?\"lang\"\s?:\s?\"(.*)\",\s?\"text\"\s?:\s?\[\s?\"(.*)\"\s?\]\s?\}/i);
							if (res) {
								tb.value = res[2];
								tb.focus();
							}
						}
					}
				}
			}
			if (!yaID) {
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
			} else {
				xhr.open('POST', 'https://translate.yandex.net/api/v1/tr.json/translate?id=' + yaID + '&srv=tr-text&lang=' + ts.value + '&reason=paste', true);
				xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
				xhr.timeout = 5000;
				xhr.send('id=' + yaID + '&srv=tr-text&lang=' + ts.value + '&reason=paste&text=' + encodeURIComponent(tb.value.trim().replace(/\s+/g," ")));
			}
		}
	}
}

function doTranslate(e, isqueue) {
	if (toTranslateQueue.length > 0 && !isqueue) return;
	if (lang == langfrom) return;
	if (e.target) {
		e.target.removeAttribute('title');
		e.target.setAttribute('translated', true);
		let s = '';
		if (toTranslateQueue.length == 0 && (apikey || yaID)) {
			translatedBuffer = '';
			toTranslateQueue = [];
			for (i = 0; i < e.target.childNodes.length; i++) {
				if (e.target.childNodes[i].nodeType == 3) {
					s += ' ' + e.target.childNodes[i].nodeValue;
				}
			}
			s = s.trim().replace(/\s+/g," ");
			if (!s) return;
		}
		let xhr = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		if (apikey) {
			e.target.removeEventListener('click', doTranslate);
			xhr.onload = function() {
				let res = this.responseXML;
				if (res) {
					if (res.firstChild.getAttribute('lang')) {
						let l = res.firstChild.getAttribute('lang');
						if (res.getElementsByTagName('text')) {
							e.target.innerHTML += ' [' + l + '] ' + res.getElementsByTagName('text')[0].childNodes[0].nodeValue;
						}
					}
				}
			}
			xhr.open('POST', 'https://translate.yandex.net/api/v1.5/tr/translate?key=' + apikey + '&options=1&format=plain&lang=' + lang, true);
			xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
			xhr.timeout = 5000;
			xhr.send('key='+apikey+'&options=1&format=plain&lang='+((langfrom=='auto') ? '' : langfrom+'-')+lang+'&text='+encodeURIComponent(s));
		} else {
			let origUrl = 'https://translate.yandex.ru/?lang=en';
			if (s) toTranslateQueue = s.split(/(\S[\.\?\!\)\;])\s+/); //{"code":413,"message":"The text size exceeds the maximum"}
			xhr.onload = function() {
				if (!yaID && this.responseURL != origUrl) {
					e.target.removeEventListener('click', doTranslate);
					e.target.innerHTML += ' [ERROR] ' + this.responseURL;
					return;
				} else {
					let res = this.responseText;
					if (res) {
						if (!yaID) {
							let sid = res.match(/\ssid: \'(.*)\'/i);
							if (sid) {
								yaID=get_yaID(sid[1]);
								//e.target.click();
								doTranslate(e);
								return;
							}
						} else {
							e.target.removeEventListener('click', doTranslate);
							res = res.match(/\{\s?\"code\"\s?:\s?200,\s?\"lang\"\s?:\s?\"(.*)\",\s?\"text\"\s?:\s?\[\s?\"(.*)\"\s?\]\s?\}/i);
							if (res) {
								translatedBuffer += res[2] + ' ';
								if (toTranslateQueue.length > 0) {
									doTranslate(e, true);
									return;
								} else {
									e.target.innerHTML += ' [' + res[1] + '] ' + translatedBuffer.trim();
									translatedBuffer = '';
								}
							}
						}
					}
				}
			}
			if (!yaID) {
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
			} else {
				let totrans = '';
				while (toTranslateQueue.length > 0) {
					totrans += toTranslateQueue[0] + (toTranslateQueue[1] ? toTranslateQueue[1] : '') + ' ';
					toTranslateQueue.splice(0,2);
					if (totrans.length > 500 || totrans.length + (toTranslateQueue[0] ? toTranslateQueue[0].length : 0) + (toTranslateQueue[1] ? toTranslateQueue[1].length : 0) > 500) break;
				}
				xhr.open('POST', 'https://translate.yandex.net/api/v1/tr.json/translate?id=' + yaID + '&srv=tr-text&lang=' + lang + '&reason=paste', true);
				xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
				xhr.timeout = 5000;
				xhr.send('id=' + yaID + '&srv=tr-text&lang=' + ((langfrom=='auto') ? '' : langfrom+'-') + lang + '&reason=paste&text=' + encodeURIComponent(totrans.trim()));
			}
		}
	}
}


function translate_post(e, isqueue) {
	if (toTranslateQueue.length > 0 && !isqueue) return;
	if (lang == langfrom) return;
	if (e.target) {
		let t = e.target.parentNode.parentNode.parentNode.querySelector('p.forum-post__message');
		if (!t) t = e.target.parentNode.parentNode.parentNode.querySelector('div.message-thread__message__body');
		let s = '';
		if (toTranslateQueue.length == 0 && (apikey || yaID)) {
			translatedBuffer = '';
			toTranslateQueue = [];
			for (i = 0; i < t.childNodes.length; i++) {
				if (t.childNodes[i].nodeType == 3) {
					s += ' ' + t.childNodes[i].nodeValue;
				}
			}
			s = s.trim().replace(/\s+/g," ");
			if (!s) return;
		}
		let xhr = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		if (apikey) {
			xhr.onload = function() {
				let res = this.responseXML;
				if (res) {
					if (res.firstChild.getAttribute('lang')) {
						let l = res.firstChild.getAttribute('lang');
						if (res.getElementsByTagName('text')) {
							t.innerHTML += '<br>[' + l + ']<br>' + res.getElementsByTagName('text')[0].childNodes[0].nodeValue;
						}
					}
				}
				e.target.remove();
			}
			xhr.open('POST', 'https://translate.yandex.net/api/v1.5/tr/translate?key=' + apikey + '&options=1&format=plain&lang=' + lang, true);
			xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
			xhr.timeout = 5000;
			xhr.send('key='+apikey+'&options=1&format=plain&lang='+((langfrom=='auto') ? '' : langfrom+'-')+lang+'&text='+encodeURIComponent(s));
			e.target.remove();
		} else {
			let origUrl = 'https://translate.yandex.ru/?lang=en';
			if (s) toTranslateQueue = s.split(/(\S[\.\?\!\)\;])\s+/); //{"code":413,"message":"The text size exceeds the maximum"}
			xhr.onload = function() {
				if (!yaID && this.responseURL != origUrl) {
					e.target.remove();
					t.innerHTML += '<br>[ERROR]<br><a href="' + this.responseURL + '">' + this.responseURL + '</a>';
					return;
				} else {
					let res = this.responseText;
					if (res) {
						if (!yaID) {
							let sid = res.match(/\ssid: \'(.*)\'/i);
							if (sid) {
								yaID=get_yaID(sid[1]);
								e.target.click();
								return;
							}
						} else {
							res = res.match(/\{\s?\"code\"\s?:\s?200,\s?\"lang\"\s?:\s?\"(.*)\",\s?\"text\"\s?:\s?\[\s?\"(.*)\"\s?\]\s?\}/i);
							if (res) {
								translatedBuffer += res[2] + ' ';
								if (toTranslateQueue.length > 0) {
									translate_post(e, true);
									return;
								} else {
									e.target.remove();
									t.innerHTML += '<br>[' + res[1] + ']<br>' + translatedBuffer.trim();
									translatedBuffer = '';
								}
							}
						}
					}
				}
			}
			if (!yaID) {
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
			} else {
				let totrans = '';
				while (toTranslateQueue.length > 0) {
					totrans += toTranslateQueue[0] + (toTranslateQueue[1] ? toTranslateQueue[1] : '') + ' ';
					toTranslateQueue.splice(0,2);
					if (totrans.length > 500 || totrans.length + (toTranslateQueue[0] ? toTranslateQueue[0].length : 0) + (toTranslateQueue[1] ? toTranslateQueue[1].length : 0) > 500) break;
				}
				xhr.open('POST', 'https://translate.yandex.net/api/v1/tr.json/translate?id=' + yaID + '&srv=tr-text&lang=' + lang + '&reason=paste', true);
				xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
				xhr.timeout = 5000;
				xhr.send('id=' + yaID + '&srv=tr-text&lang=' + ((langfrom=='auto') ? '' : langfrom+'-') + lang + '&reason=paste&text=' + encodeURIComponent(totrans.trim()));
			}
		}
	}
}

function translate_my_post(e, isqueue) {
	if (toTranslateQueue.length > 0 && !isqueue) return;
	let ts = e.target.ownerDocument.querySelector('.post_translate_select');
	if (!ts) return;
	mylangto = ts.value;
	myPrefs.setCharPref('langto', mylangto);
	let tb = e.target.ownerDocument.querySelector('textarea#form3-text.form-control.post-text-area');
	if (!tb) tb = e.target.ownerDocument.querySelector('textarea.form-control');
	if (!tb) tb = e.target.ownerDocument.querySelector('textarea.msg-app__convo__post__text');
	if (tb) {
		if (tb.value.length == 0) return;
		let s = '';
		if (toTranslateQueue.length == 0 && (apikey || yaID)) {
			translatedBuffer = '';
			toTranslateQueue = [];
			s = tb.value.trim().replace(/\s+/g," ");
			if (!s) return;
		}
		let xhr = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		if (apikey) {
			xhr.onload = function() {
				let res = this.responseXML;
				if (res) {
					if (res.firstChild.getAttribute('lang')) {
						if (res.getElementsByTagName('text')) {
							tb.value = res.getElementsByTagName('text')[0].childNodes[0].nodeValue;
							tb.focus();
						}
					}
				}
			}
			xhr.open('POST', 'https://translate.yandex.net/api/v1.5/tr/translate?key=' + apikey + '&options=1&format=plain&lang=' + ts.value, true);
			xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
			xhr.timeout = 5000;
			xhr.send('key='+apikey+'&options=1&format=plain&lang='+ts.value+'&text='+encodeURIComponent(s));
		} else {
			let origUrl = 'https://translate.yandex.ru/?lang=en';
			if (s) toTranslateQueue = s.split(/(\S[\.\?\!\)\;])\s+/); //{"code":413,"message":"The text size exceeds the maximum"}
			xhr.onload = function() {
				if (!yaID && this.responseURL != origUrl) {
					tb.value += ' [ERROR] ' + res.redirectedurl;
					return;
				} else {
					let res = this.responseText;
					if (res) {
						if (!yaID) {
							let sid = res.match(/\ssid: \'(.*)\'/i);
							if (sid) {
								yaID=get_yaID(sid[1]);
								e.target.ownerDocument.querySelector('.translate_my_post').click();
								return;
							}
						} else {
							res = res.match(/\{\s?\"code\"\s?:\s?200,\s?\"lang\"\s?:\s?\"(.*)\",\s?\"text\"\s?:\s?\[\s?\"(.*)\"\s?\]\s?\}/i);
							if (res) {
								translatedBuffer += res[2] + ' ';
								if (toTranslateQueue.length > 0) {
									translate_my_post(e, true);
									return;
								} else {
									tb.value = translatedBuffer.trim();
									translatedBuffer = '';
									tb.focus();
								}
							}
						}
					}
				}
			}
			if (!yaID) {
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
			} else {
				let totrans = '';
				while (toTranslateQueue.length > 0) {
					totrans += toTranslateQueue[0] + (toTranslateQueue[1] ? toTranslateQueue[1] : '') + ' ';
					toTranslateQueue.splice(0,2);
					if (totrans.length > 500 || totrans.length + (toTranslateQueue[0] ? toTranslateQueue[0].length : 0) + (toTranslateQueue[1] ? toTranslateQueue[1].length : 0) > 500) break;
				}
				xhr.open('POST', 'https://translate.yandex.net/api/v1/tr.json/translate?id=' + yaID + '&srv=tr-text&lang=' + ts.value + '&reason=paste', true);
				xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
				xhr.timeout = 5000;
				xhr.send('id=' + yaID + '&srv=tr-text&lang=' + ts.value + '&reason=paste&text=' + encodeURIComponent(totrans.trim()));
			}
		}
	}
}



function inspect_chat(mchat) {
	if (!mchat.getAttribute('readytotranslate')) {
		mchat.setAttribute('readytotranslate', true);
		let tNodes = mchat.querySelectorAll('t');
		//let lang = getPreference().lang;
		for (i = 0; i < tNodes.length; i++) {
			if (!tNodes[i].getAttribute('translated')) {
				tNodes[i].setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
				tNodes[i].addEventListener('click', doTranslate);
			}
		}
		mchat.addEventListener('DOMNodeInserted', modifyObj, false);
		mchat.addEventListener('DOMNodeRemoved', function(e) {
				e.relatedNode.addEventListener('DOMSubtreeModified', makeReady, false);
		}, false);
		let chattab = mchat.ownerDocument.querySelector('.mchat__tabs');
		if (chattab) {
			if (chattab.querySelector('.mchat__translate_to')) return;
			let tb = mchat.ownerDocument.createElement('BUTTON');
			tb.setAttribute('class', 'mchat__translate_to');
			tb.setAttribute('title', stringBundle.GetStringFromName('Translate my message'));
			tb.setAttribute('style', 'padding:0px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;');
			tb.innerHTML='<\u042f';
			tb.addEventListener('click', doMyButtonClick, false);
			let sl = mchat.ownerDocument.createElement('SELECT');
			sl.setAttribute('class', 'mchat__translate_select');
			sl.setAttribute('title', stringBundle.GetStringFromName('Translate my messages to...'));
			sl.setAttribute('style', 'overflow:hidden;padding:0px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:block;outline:none;');
			for (var i in langs) {
				let op = mchat.ownerDocument.createElement('OPTION');
				op.innerHTML = i;
				op.setAttribute('title', langs[i]);
				op.setAttribute('value', i);
				if (i == mylangto) op.setAttribute('selected', true);
				sl.appendChild(op);
			}
			chattab.appendChild(sl);
			chattab.appendChild(tb);
		}
	}
}

function makeReady(e) {
	if (!e.target.querySelector) return;
	let mchat = e.target.querySelector('.mchat__messages');
	if (mchat) {
		inspect_chat(mchat);
		mchat.ownerDocument.documentElement.removeEventListener('DOMSubtreeModified', makeReady, false);
		e.target.removeEventListener('DOMSubtreeModified', makeReady, false);
	}
}

function makeReadyPrivate(e) {
	if (!e.target.querySelector || !e.target.matches || !e.target.matches('group')) return;
	let els = e.target.querySelectorAll('group their t');
	for (let i of els) {
		if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
			i.setAttribute('readytotranslate', true);
			i.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
			i.addEventListener('click', doTranslate);
		}
	}
}

function modifyObj(e) {
	if (!e.target.querySelector) return;
	let message_t = e.target.querySelector('t');
	if (message_t) {
		message_t.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
		message_t.addEventListener('click', doTranslate);
	}
}

function div_comment_div_content_mod(e) {
	if (e && e.target) {
		e.target.setAttribute('readytotranslate', true);
		e.target.removeAttribute('translated');
		e.target.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
		e.target.addEventListener('click', div_comment_div_content_cl);
	}
}
function div_comment_div_content_mod2(e) {
	e.target.removeEventListener('DOMSubtreeModified', div_comment_div_content_mod2, false);
	e.target.addEventListener('DOMSubtreeModified', div_comment_div_content_mod, false);
}
function div_comment_div_content_cl(e) {
	e.target.removeEventListener('DOMSubtreeModified', div_comment_div_content_mod, false);
	e.target.removeEventListener('click', div_comment_div_content_cl);
	doTranslate(e);
	e.target.addEventListener('DOMSubtreeModified', div_comment_div_content_mod2, false);
}

function MainAnalyseCook(e, el) {
	if (e && e.target && e.target.matches
	    && (e.target.matches('div.analyse__tools') || e.target.matches('div.gamebook')
	        || e.target.matches('div.analyse__underboard')
	        || e.target.matches('div.comment')
	        || e.target.matches('div.msg-app__convo'))) {
		let p = e.target.parentNode;
		setTimeout(function() {if (p) MainAnalyseCook(false, p)}, 3000);
		return;
	} else if (el) {
		let els = el.querySelector('div.analyse__tools');
		if (els) els.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		els = el.querySelectorAll('interrupt comment');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		els = el.querySelector('div.gamebook');
		if (els) els.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		els = el.querySelectorAll('div.comment div.content');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', div_comment_div_content_cl);
					i.addEventListener('DOMSubtreeModified', div_comment_div_content_mod, false);
					i.parentNode.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
				}
			}
		}
		els = el.querySelector('div.analyse__underboard');
		if (els) els.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		els = el.querySelectorAll('div.feedback div.comment');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		els = el.querySelectorAll('div.study-desc div.text');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		
		els = el.querySelectorAll('group their t');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		els = el.querySelector('textarea.msg-app__convo__post__text');
		if (els) {
			if (!els.parentNode.getAttribute('readytotranslate')) {
				els.parentNode.setAttribute('readytotranslate', true);
				let tb = el.ownerDocument.createElement('BUTTON');
				tb.setAttribute('type', 'button');
				tb.setAttribute('class', 'translate_my_post');
				tb.setAttribute('title', stringBundle.GetStringFromName('Translate my message'));
				tb.setAttribute('style', 'padding:0 0 0 2px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;display:block;');
				tb.innerHTML='<\u042f';
				tb.addEventListener('click', translate_my_post, false);
				let sl = el.ownerDocument.createElement('SELECT');
				sl.setAttribute('class', 'post_translate_select');
				sl.setAttribute('title', stringBundle.GetStringFromName('Translate my messages to...'));
				sl.setAttribute('style', 'overflow:hidden;padding:0 0 0 2px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:block;outline:none;');
				for (var i in langs) {
					let op = el.ownerDocument.createElement('OPTION');
					op.innerHTML = i;
					op.setAttribute('title', langs[i]);
					op.setAttribute('value', i);
					if (i == mylangto) op.setAttribute('selected', true);
					sl.appendChild(op);
				}
				let dd = el.ownerDocument.createElement('DIV');
				dd.appendChild(sl);
				dd.appendChild(tb);
				els.parentNode.parentNode.appendChild(dd);
			}
		}
		els = el.querySelector('div.msg-app__convo__msgs__content');
		if (els) {
			els.removeEventListener('DOMNodeInserted', makeReadyPrivate, false);
			els.addEventListener('DOMNodeInserted', makeReadyPrivate, false);
		}
	}
}

function readyDoc(e, theDoc) {
	if (e && e.target && e.target.readyState && e.target.readyState === 'complete') {
		setTimeout(function() {if (e && e.target) readyDoc(false, e.target)}, 3000);
		return;
	}
	if (!theDoc) return;
	
	let mchat = theDoc.querySelector('div.analyse__tools');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	mchat = theDoc.querySelector('div.gamebook');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	mchat = theDoc.querySelector('div.analyse__underboard');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	
	mchat = theDoc.querySelector('main.msg-app');
	//mchat = theDoc.querySelector('div.msg-app__convo');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	mchat = theDoc.querySelector('div.msg-app__convo__msgs__content');
	if (mchat) {
		mchat.removeEventListener('DOMNodeInserted', makeReadyPrivate, false);
		mchat.addEventListener('DOMNodeInserted', makeReadyPrivate, false);
	}
	
	mchat = theDoc.querySelector('.mchat__messages');
	if (mchat) {
		inspect_chat(mchat);
		return;
	}
	mchat = theDoc.querySelector('.mchat__content');
	if (mchat) {
		theDoc.documentElement.addEventListener('DOMSubtreeModified', makeReady, false);
		mchat.addEventListener('DOMSubtreeModified', makeReady, false);
		return;
	}
	
	let private_thread = false;
	mchat = theDoc.querySelectorAll('article.forum-post');
	if (!mchat.length) {
		private_thread = true;
		mchat = theDoc.querySelectorAll('article.message-thread__message');
	}
	if (mchat.length > 0) {
		for (i = 0; i < mchat.length; i++) {
			if (!mchat[i].getAttribute('readytotranslate')) {
				mchat[i].setAttribute('readytotranslate', true);
				let tb = theDoc.createElement('BUTTON');
				tb.setAttribute('class', 'post_translate_to');
				tb.setAttribute('title', stringBundle.GetStringFromName('Translate to') + ' [' + lang + ']...');
				tb.setAttribute('style', 'padding:0 10px 0 10px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;');
				tb.innerHTML='[\u042f]';
				tb.addEventListener("click", translate_post, false);
				let p = null;
				if (private_thread) p = mchat[i].querySelector('div.infos > div');
				else p = mchat[i].querySelector('.forum-post__metas > div');
				if (p) p.appendChild(tb);
			}
		}
	}
	
	private_thread = false;
	mchat = theDoc.querySelector('div.form-group > textarea');
	//if (!mchat) {
	//	private_thread = true;
	//	mchat = theDoc.querySelector('div.message-thread__answer > form > div > textarea');
	//}
	if (!mchat) {
		private_thread = true;
		mchat = theDoc.querySelector('textarea.msg-app__convo__post__text');
	}
	if (mchat) {
		if (!mchat.parentNode.getAttribute('readytotranslate')) {
			mchat.parentNode.setAttribute('readytotranslate', true);
			let tb = theDoc.createElement('BUTTON');
			tb.setAttribute('type', 'button');
			tb.setAttribute('class', 'translate_my_post');
			tb.setAttribute('title', stringBundle.GetStringFromName('Translate my message'));
			if (private_thread) {
				tb.setAttribute('style', 'padding:0 0 0 2px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;display:block;');
			} else {
				tb.setAttribute('style', 'padding:0 1px 3px 1px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;display:inline-block;');
			}
			tb.innerHTML='<\u042f';
			tb.addEventListener('click', translate_my_post, false);
			let sl = theDoc.createElement('SELECT');
			sl.setAttribute('class', 'post_translate_select');
			sl.setAttribute('title', stringBundle.GetStringFromName('Translate my messages to...'));
			if (private_thread) {
				sl.setAttribute('style', 'overflow:hidden;padding:0 0 0 2px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:block;outline:none;');
			} else {
				sl.setAttribute('style', 'overflow:hidden;padding:0 1px 3px 1px;margin:1px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:inline-block;outline:none;');
			}
			for (var i in langs) {
				let op = theDoc.createElement('OPTION');
				op.innerHTML = i;
				op.setAttribute('title', langs[i]);
				op.setAttribute('value', i);
				if (i == mylangto) op.setAttribute('selected', true);
				sl.appendChild(op);
			}
			if (private_thread) {
				//mchat.parentNode.insertBefore(sl, mchat);
				//mchat.parentNode.insertBefore(tb, mchat);
				let dd = theDoc.createElement('DIV');
				dd.appendChild(sl);
				dd.appendChild(tb);
				mchat.parentNode.parentNode.appendChild(dd);
			} else {
				mchat.parentNode.appendChild(sl);
				mchat.parentNode.appendChild(tb);
			}
		}
	}
	
}

function addDiv(theDoc) {
	if (!theDoc) {
		Cu.reportError('no theDoc!');
		//document not provided, it is undefined likely
		return;
	}
	let location = (theDoc.location + '');
	//if (location.toLowerCase().indexOf(locationToMatch) == -1) {
	if (!location.toLowerCase().match(locationToMatch)) {
		return;
	}
	//Cu.reportError('theDoc location matches locationToMatch:' + theDoc.location)
	if (!theDoc instanceof Ci.nsIDOMHTMLDocument) {
		//not html document, so its likely an xul document
		Cu.reportError('theDoc is not an HTML document, it is probably XUL, since i chose to add HTML element, i dont want to add to xul elements, so exit');
		return;
	}
	
	getPreference();
	
	if (theDoc.readyState === 'complete') {
		setTimeout(function() {readyDoc(false, theDoc)}, 3000);
	} else {
		theDoc.addEventListener('readystatechange', readyDoc, false);
	}
}

function listenPageLoad(event) {
	let win = event.originalTarget.defaultView;
	let doc = win.document;
	if (win.frameElement) {
		//its a frame
		//Cu.reportError('a frame loaded');
		if (ignoreFrames) {
			return;
		}
	}
	addDiv(doc);
}

/*start - windowlistener*/
var windowListener = {
	//DO NOT EDIT HERE
	onOpenWindow: function (aXULWindow) {
		// Wait for the window to finish loading
		let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
		aDOMWindow.addEventListener('load', function () {
			aDOMWindow.removeEventListener('load', arguments.callee, false);
			windowListener.loadIntoWindow(aDOMWindow, aXULWindow);
		}, false);
	},
	onCloseWindow: function (aXULWindow) {},
	onWindowTitleChange: function (aXULWindow, aNewTitle) {},
	register: function () {
		// Load into any existing windows
		let XULWindows = Services.wm.getXULWindowEnumerator(null);
		while (XULWindows.hasMoreElements()) {
			let aXULWindow = XULWindows.getNext();
			let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
			windowListener.loadIntoWindow(aDOMWindow, aXULWindow);
		}
		// Listen to new windows
		Services.wm.addListener(windowListener);
	},
	unregister: function () {
		// Unload from any existing windows
		let XULWindows = Services.wm.getXULWindowEnumerator(null);
		while (XULWindows.hasMoreElements()) {
			let aXULWindow = XULWindows.getNext();
			let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
			windowListener.unloadFromWindow(aDOMWindow, aXULWindow);
		}
		//Stop listening so future added windows dont get this attached
		Services.wm.removeListener(windowListener);
	},
	//END - DO NOT EDIT HERE
	loadIntoWindow: function (aDOMWindow, aXULWindow) {
		if (!aDOMWindow) {
			return;
		}
		if (aDOMWindow.gBrowser) {
			aDOMWindow.gBrowser.addEventListener('DOMContentLoaded', listenPageLoad, false);
			if (aDOMWindow.gBrowser.tabContainer) {
				//has tabContainer
				//start - go through all tabs in this window we just added to
				let tabs = aDOMWindow.gBrowser.tabContainer.childNodes;
				for (var i = 0; i < tabs.length; i++) {
//					Cu.reportError('DOING tab: ' + i);
					let tabBrowser = tabs[i].linkedBrowser;
					let win = tabBrowser.contentWindow;
					loadIntoContentWindowAndItsFrames(win);
				}
				//end - go through all tabs in this window we just added to
			} else {
				//does not have tabContainer
				let win = aDOMWindow.gBrowser.contentWindow;
				loadIntoContentWindowAndItsFrames(win);
			}
		} else {
			//window does not have gBrowser
		}
	},
	unloadFromWindow: function (aDOMWindow, aXULWindow) {
		if (!aDOMWindow) {
			return;
		}
		if (aDOMWindow.gBrowser) {
			aDOMWindow.gBrowser.removeEventListener('DOMContentLoaded', listenPageLoad, false);
			if (aDOMWindow.gBrowser.tabContainer) {
				//has tabContainer
				//start - go through all tabs in this window we just added to
				let tabs = aDOMWindow.gBrowser.tabContainer.childNodes;
				for (var i = 0; i < tabs.length; i++) {
//					Cu.reportError('DOING tab: ' + i);
					let tabBrowser = tabs[i].linkedBrowser;
					let win = tabBrowser.contentWindow;
					unloadFromContentWindowAndItsFrames(win);
				}
				//end - go through all tabs in this window we just added to
			} else {
				//does not have tabContainer
				let win = aDOMWindow.gBrowser.contentWindow;
				unloadFromContentWindowAndItsFrames(win);
			}
		} else {
			//window does not have gBrowser
		}
	}
};
/*end - windowlistener*/

function loadIntoContentWindowAndItsFrames(theWin) {
	let frames = theWin.frames;
	let winArr = [theWin];
	for (var j = 0; j < frames.length; j++) {
		winArr.push(frames[j].window);
	}
//	Cu.reportError('# of frames in tab: ' + frames.length);
	for (var j = 0; j < winArr.length; j++) {
		let doc = winArr[j].document;
		//START - edit below here
		addDiv(doc);
		if (ignoreFrames) {
			break;
		}
		//END - edit above here
	}
	if (firststart) {
		firststart = null;
		theWin.openDialog('chrome://LichessChatTranslator/content/options.xul', 'LichessChatTranslator', 'chrome,titlebar,toolbar,centerscreen,dialog=yes');
	}
}

function unloadFromContentWindowAndItsFrames(theWin) {
	let frames = theWin.frames;
	let winArr = [theWin];
	for (var j = 0; j < frames.length; j++) {
		winArr.push(frames[j].window);
	}
//	Cu.reportError('# of frames in tab: ' + frames.length);
	for (var j = 0; j < winArr.length; j++) {
		let doc = winArr[j].document;
		//START - edit below here
		if (ignoreFrames) {
			break;
		}
		//END - edit above here
	}
}

function startup(aData, aReason) {
	windowListener.register();
}

function shutdown(aData, aReason) {
	if (aReason == APP_SHUTDOWN) return;
	if (windowListener) windowListener.unregister();
}

function install(e) {
	firststart = true;
}

function uninstall() {}
